using System;
using System.Collections.Generic;

namespace Sonex.Client.Data
{
    public sealed class DataColumnGuid : DataColumnBase
    {
        public List<Guid?> Values { get; } = new();

        public override Type DataType => typeof(Guid);
        public override int RowCount => Values.Count;

        public DataColumnGuid(string key, string header, int initialRowCount = 0)
            : base(key, header)
        {
            ValueFormat = "D";

            for (int i = 0; i < initialRowCount; i++)
                Values.Add(null);
        }

        protected override string? FormatValue(int rowIndex)
        {
            Guid? value = Values[rowIndex];
            if (value is null)
                return null;

            return value.Value.ToString(
                string.IsNullOrWhiteSpace(ValueFormat)
                    ? "D"
                    : ValueFormat);
        }

        public override void SetValue(int rowIndex, string? value)
        {
            ValidateRowIndex(rowIndex);

            if (string.IsNullOrWhiteSpace(value))
            {
                Values[rowIndex] = null;
                return;
            }

            if (!Guid.TryParse(value, out Guid result))
                throw new FormatException($"Value '{value}' is not a valid Guid.");

            Values[rowIndex] = result;
        }

        public override object? GetRawValue(int rowIndex)
        {
            ValidateRowIndex(rowIndex);
            return Values[rowIndex];
        }

        public override void SetRawValue(int rowIndex, object? value)
        {
            ValidateRowIndex(rowIndex);

            if (value is null)
            {
                Values[rowIndex] = null;
                return;
            }

            if (value is Guid guidValue)
            {
                Values[rowIndex] = guidValue;
                return;
            }

            throw new InvalidCastException($"Column '{Key}' expects Guid.");
        }

        public override void AddEmpty()
        {
            Values.Add(null);
        }
    }
}